<template>
  <div class="payment-container">
    <VeeForm
      v-slot="{ handleSubmit }"
      :validation-schema="schema"
      :validateOnInput="true"
      as="div"
    >
      <form @submit="handleSubmit($event, onSubmit)">
        <BaseInput name="name" placeholder="Name" />
        <span class="nice-type">{{ niceType }}</span>
        <BaseInput name="card" placeholder="Card" />
        <BaseInput name="date" placeholder="Date" />
        <BaseInput name="cvv" placeholder="CVV" />
        <button>Submit</button>
      </form>
    </VeeForm>
    <div>
        <div ref="paypal"></div>
      <transition name="fade">
        <h3 v-if="paypalStatus" class="paypal-message">{{ paypalStatus }}</h3>
      </transition>
    </div>
  </div>
</template>
<script lang="ts" setup>
import { onMounted, ref } from "vue";
import { Form as VeeForm } from "vee-validate";
import * as yup from "yup";
import valid from "card-validator";
import BaseInput from "@/components/BaseInput.vue";

const paypalStatus = ref();
paypalStatus.value = "completed";
setTimeout(() => {
  paypalStatus.value = null;
}, 10000);
const paypal = ref(null);
const loaded = ref(false);
const paidFor = ref(false);
const clientID =
  "Aeyoyfo36vec1pyX2q-cU_KKmQ1p6732OXnVUeJO3FgTsK-yekA4Y_9RSWQx6gnE7EqP9U8bZw2bcwcV";

const niceType = ref();

const schema = yup.object({
  name: yup
    .string()
    .matches(
      /^([A-Za-z\u00C0-\u00D6\u00D8-\u00f6\u00f8-\u00ff\s]*)$/g,
      "Name can only contain Latin letters."
    )
    .matches(
      /^(?:([A-Za-z\u00C0-\u00D6\u00D8-\u00f6\u00f8-\u00ff\s]*)) (?:([A-Za-z\u00C0-\u00D6\u00D8-\u00f6\u00f8-\u00ff\s]*))$/g,
      "Please enter your full name."
    )
    .required(),
  card: yup
    .string()
    .test("test-number", "Credit card number is invalid", (value: unknown) => {
      niceType.value = valid.number(value).card?.niceType;
      return valid.number(value).isValid;
    }),
  date: yup
    .string()
    .test(
      "test-number",
      "Expiration date is invalid",
      (value: unknown) => valid.expirationDate(value).isValid
    ),
  cvv: yup
    .string()
    .test(
      "test-number",
      "CVV is invalid",
      (value: unknown) => valid.cvv(value).isValid
    ),
});

function onSubmit() {
  alert("Form has been submitted!");
}

function setLoaded() {
  loaded.value = true;
  window.paypal
    .Buttons({
      createOrder: (
        data: any,
        actions: {
          order: {
            create: (arg0: {
              purchase_units: {
                description: string;
                amount: { currency_code: string; value: number };
              }[];
            }) => any;
          };
        }
      ) => {
        return actions.order.create({
          purchase_units: [
            {
              description: "",
              amount: {
                currency_code: "USD",
                value: 100,
              },
            },
          ],
        });
      },
      onApprove: async (
        data: any,
        actions: { order: { capture: () => any } }
      ) => {
        const order = await actions.order.capture();
        paidFor.value = true;
        paypalStatus.value = order.status;
        setTimeout(() => {
          paypalStatus.value = null;
        }, 10000);
      },
      onError: (err: any) => {
        console.log(err);
      },
    })
    .render(paypal.value);
}

onMounted(() => {
  const script = document.createElement("script");
  script.src = `https://www.paypal.com/sdk/js?client-id=${clientID}`;
  script.addEventListener("load", setLoaded);
  document.body.appendChild(script);
});
</script>

<style scoped lang="scss">
.payment-container {
  display: flex;
  width: 100%;
  margin-top: 20px;
  flex-direction: column;
  > :first-child {
    margin-bottom: 40px;
  }

  > div {
    width: 100%;
    max-width: 300px;
  }

  @media (min-width: 1024px) {
    flex-direction: row;
    > :first-child {
      margin-bottom: 0;
      margin-right: 40px;
    }
  }
}
form {
  position: relative;
  width: 100%;
  display: flex;
  flex-direction: column;
  background-color: white;
  border-radius: 8px;
  padding: 20px;
  box-shadow: 0 4px 6px -1px rgb(0 0 0 / 0.1), 0 2px 4px -2px rgb(0 0 0 / 0.1);

  .nice-type {
    padding-left: 12px;
    position: relative;
    font-size: 12px;
    top: -4px;
  }

  button {
    width: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
    border-radius: 6px;
    box-shadow: 0 1px 2px 0 rgb(0 0 0 / 0.05);
    outline: none;
    animation: transition 0.3s ease-in-out;
    padding: 8px 12px;
    border: 1px solid rgb(31 41 55);
    cursor: pointer;

    &:focus {
      outline: none;
      box-shadow: 0 4px 6px -1px rgb(0 0 0 / 0.1),
        0 2px 4px -2px rgb(0 0 0 / 0.1);
    }
    &:hover {
      text-decoration: none;
      box-shadow: 0 4px 6px -1px rgb(0 0 0 / 0.1),
        0 2px 4px -2px rgb(0 0 0 / 0.1);
    }
  }
}

.paypal-message {
  margin-top: 20px;
  text-align: center;
  color: rgb(22 163 74);
}

.fade-enter-active,
.fade-leave-active {
  transition: all 0.3s ease;
}

.fade-enter-from,
.fade-leave-to {
  opacity: 0;
  transform: translateX(20px);
}
</style>
